// Exercise 9.6 p. 387

var x, y, z, k: int;

function exp(x: int, y: int) returns (z: int);
axiom (forall x: int :: exp(x,0) == 1);
axiom (forall x: int, y: int :: exp(x,y) == mult(x,exp(x,y-1)));

// For good old multiplication in the logic.
function mult(x: int, y: int) returns (z: int);
// Multiplication is associative.
axiom (forall x: int, y: int, z: int :: mult(x, mult(y, z)) == mult(mult(x, y), z));

// Instead of using *, we'll use times:
procedure times(x: int, y: int) returns (z: int);
        ensures z == mult(x,y);
        
// For integer division in the logic.
function div(x: int, y: int) returns (z: int);

// Instead of using /, we'll use divide:
procedure divide(x: int, y: int) returns (z: int);
        ensures z == div(x, y);
        
// A predicate for the logic expressing that a number is even.
function even(x: int) returns (b: bool);

// Instead of using x % 2 == 0 in our program, we'll call is_even.
procedure is_even(x: int) returns (b: bool);
        ensures (b == even(x));

// A relationship between even, exp, mult and div:
axiom (forall x: int, y: int :: even(y) ==> (exp(mult(x,x),div(y,2)) == exp(x,y)));

procedure exercise_9_6_4()
        requires mult(z, exp(x,y)) == k;
        ensures mult(z, exp(x,y)) == k;
        modifies x,y,z;
{
        var b: bool;
        call b := is_even(y);
        goto oddlabel, evenlabel;
        oddlabel:  assume !b;
                   y := y - 1;
                   call z := times(z,x);
                   goto fi;
        evenlabel: assume b;
                   call y := divide(y, 2);
                   call x := times(x, x);
        fi:
}

procedure alternative_exercise_9_6_4()
        requires mult(z, exp(x,y)) == k;
        ensures mult(z, exp(x,y)) == k;
        modifies x,y,z;
{
        var b: bool;
        call b := is_even(y);
        if (!b) {
                   y := y - 1;
                   call z := times(z,x);
        } else {
                   call y := divide(y, 2);
                   call x := times(x, x);
        }
}
